#pragma once
#include "../BasicAbstractions/Command.h"
#include "../Application/IState.h"
#include "ExitState/ExitState.h"

struct ChangeStateCommand : ISelectCommand {
    explicit ChangeStateCommand(IStateManager& state_manager) : m_state_manager(state_manager) {}
protected:
    IStateManager& m_state_manager;
};

struct ExitCommand : ChangeStateCommand {
    using ChangeStateCommand::ChangeStateCommand;
    void execute() override { m_state_manager.set_next_state(std::make_unique<ExitState>(m_state_manager)); }
};

class GameBuilderDirector {}; /// @todo когда напишу - убрать

class GameCommand : public ChangeStateCommand {
public:
    GameCommand(IStateManager& state_manager, std::unique_ptr<GameBuilderDirector> ptr_director) :
        ChangeStateCommand(state_manager), m_ptr_director(std::move(ptr_director)) {}
    void execute() override { m_state_manager.set_next_state(std::make_unique<ExitState>(m_state_manager)); } /// @todo поменять
private:
    std::unique_ptr<GameBuilderDirector> m_ptr_director;
};

